package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_coupon.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_coupon.git/utils"
	"xorm.io/xorm"
)

//统计数量
func GetCouponUserTotalByLeaveSum(Db *xorm.Engine, condition *model.CommCouponUserTotal, cols string) (float64, error) {
	total, err := Db.Sum(condition, cols)
	if err != nil {
		return 0, err
	}
	return total, err
}
func GetCouponUserByUid(Db *xorm.Engine, uid string) (*[]model.CommCouponUserTotal, error) {
	var m []model.CommCouponUserTotal
	if err := Db.Where("uid = " + uid + " and leave_coupon_amount_value>=0  ").Asc("leave_coupon_amount_value").Find(&m); err != nil {
		return nil, err
	}
	return &m, nil
}

func GetCouponUserTotalByLeaveSumWithTypeSession(session *xorm.Session, uid int, pvdType string) (*[]model.CommCouponUserTotal, error) {
	var m []model.CommCouponUserTotal
	if err := session.Where("uid = " + utils.IntToStr(uid) + " and leave_coupon_amount_value>=0  and (pvd_type LIKE '%" + pvdType + "%' or pvd_type='ordinary' )").Asc("leave_coupon_amount_value").Find(&m); err != nil {
		return nil, err
	}
	return &m, nil
}
func GetCouponUserTotalByNegative(Db *xorm.Engine, uid int, pvdType, cols string) (float64, error) {
	var m model.CommCouponUserTotal
	total, err := Db.Where("uid = "+utils.IntToStr(uid)+" and leave_coupon_amount_value<0  and (pvd_type LIKE '%"+pvdType+"%' or pvd_type='ordinary' )").Sum(m, cols)
	if err != nil {
		return 0, err
	}
	return total, err
}

//查询对应记录
func GetCouponUserTotalByOne(session *xorm.Session, uid int, pvdType string) (*model.CommCouponUserTotal, error) {
	var m model.CommCouponUserTotal
	if has, err := session.Where("uid = ? and pvd_type=? ", uid, pvdType).Asc("leave_coupon_amount_value").Get(&m); err != nil || !has {
		return nil, err
	}
	return &m, nil
}
func GetCouponUserTotalById(eg *xorm.Engine, uid int, id string) (*model.CommCouponUserTotal, error) {
	var m model.CommCouponUserTotal
	if has, err := eg.Where("uid = ? and id=? ", uid, id).Asc("leave_coupon_amount_value").Get(&m); err != nil || !has {
		return nil, err
	}
	return &m, nil
}

//查询对应记录
func GetCouponUserTotalByOneEg(eg *xorm.Engine, uid int, pvdType string) (*model.CommCouponUserTotal, error) {
	var m model.CommCouponUserTotal
	if has, err := eg.Where("uid = ? and pvd_type=? ", uid, pvdType).Asc("leave_coupon_amount_value").Get(&m); err != nil || !has {
		return nil, err
	}
	return &m, nil
}
func GetCouponUserTotalByOneSession(session *xorm.Session, uid int, pvdType string) (*model.CommCouponUserTotal, error) {
	var m model.CommCouponUserTotal
	if has, err := session.Where("uid = ? and pvd_type=? ", uid, pvdType).Asc("leave_coupon_amount_value").Get(&m); err != nil || !has {
		return nil, err
	}
	return &m, nil
}

//写入或保存
func CouponUserTotalByInsertWithUpdate(session *xorm.Session, m *model.CommCouponUserTotal) (has int64, err error) {
	if m.Id > 0 {
		has, err = session.ID(m.Id).Cols("coupon_amount_value,leave_coupon_amount_value,user_pvd").Update(m)
	} else {
		has, err = session.InsertOne(m)
	}
	return has, err
}

//写入或保存
func CouponUserTotalByInsertWithUpdateEg(eg *xorm.Engine, m *model.CommCouponUserTotal) (has int64, err error) {
	if m.Id > 0 {
		has, err = eg.ID(m.Id).Cols("coupon_amount_value,leave_coupon_amount_value").Update(m)
	} else {
		has, err = eg.InsertOne(m)
	}
	return has, err
}
